// Based on:
// File by Steve Demlow
// Recursive Menger Sponge demo #2

#if (CorCubeLevel = 1)
    difference {
        box { <-0.5,-0.5,-0.5>,<0.5,0.5,0.5> }
        box { <-0.51,-0.166667,-0.166667>,<0.51,0.166667,0.166667> }
        box { <-0.166667,-0.51,-0.166667>,<0.166667,0.51,0.166667> }
        box { <-0.166667,-0.166667,-0.51>,<0.166667,0.166667,0.51> }
        scale CorCubeRad
        translate CorCubeCen
    }
#else
    // Recursively draw 20 smaller CorCubes.  Can't use loops here since
    // the indices would be changed by the recursive calls.

    #declare CorCubeLevel = CorCubeLevel - 1
    #declare CorCubeRad = CorCubeRad / 3

    // Top layer

    #if (CorCubeLevel = TotalLevel-1) #render "8.3\n" #end
    #declare CorCubeCen = CorCubeCen + <-CorCubeRad,-CorCubeRad,-CorCubeRad>
    #include "cube2.inc"
    #declare CorCubeCen = CorCubeCen + <CorCubeRad,0,0>
    #if (CorCubeLevel = TotalLevel-1) #render "8.2\n" #end
    #include "cube2.inc"
    #declare CorCubeCen = CorCubeCen + <CorCubeRad,0,0>
    #if (CorCubeLevel = TotalLevel-1) #render "8.1\n" #end
    #include "cube2.inc"

    #if (CorCubeLevel = TotalLevel-1) #render "7\n" #end
    #declare CorCubeCen = CorCubeCen + <-CorCubeRad * 2,CorCubeRad,0>
    #include "cube2.inc"
    #declare CorCubeCen = CorCubeCen + <CorCubeRad * 2,0,0>
    #include "cube2.inc"

    #if (CorCubeLevel = TotalLevel-1) #render "6\n" #end
    #declare CorCubeCen = CorCubeCen + <-CorCubeRad * 2,CorCubeRad,0>
    #include "cube2.inc"
    #declare CorCubeCen = CorCubeCen + <CorCubeRad,0,0>
    #include "cube2.inc"
    #declare CorCubeCen = CorCubeCen + <CorCubeRad,0,0>
    #include "cube2.inc"

    // Middle layer

    #if (CorCubeLevel = TotalLevel-1) #render "5\n" #end
    #declare CorCubeCen = CorCubeCen + <-CorCubeRad * 2,-CorCubeRad * 2,CorCubeRad>
    #include "cube2.inc"
    #declare CorCubeCen = CorCubeCen + <CorCubeRad * 2,0,0>
    #include "cube2.inc"

    #if (CorCubeLevel = TotalLevel-1) #render "4\n" #end
    #declare CorCubeCen = CorCubeCen + <-CorCubeRad * 2,CorCubeRad * 2,0>
    #include "cube2.inc"
    #declare CorCubeCen = CorCubeCen + <CorCubeRad * 2,0,0>
    #include "cube2.inc"

    // Bottom layer

    #if (CorCubeLevel = TotalLevel-1) #render "3\n" #end
    #declare CorCubeCen = CorCubeCen + <-CorCubeRad * 2,-CorCubeRad * 2,CorCubeRad>
    #include "cube2.inc"
    #declare CorCubeCen = CorCubeCen + <CorCubeRad,0,0>
    #include "cube2.inc"
    #declare CorCubeCen = CorCubeCen + <CorCubeRad,0,0>
    #include "cube2.inc"

    #if (CorCubeLevel = TotalLevel-1) #render "2\n" #end
    #declare CorCubeCen = CorCubeCen + <-CorCubeRad * 2,CorCubeRad,0>
    #include "cube2.inc"
    #declare CorCubeCen = CorCubeCen + <CorCubeRad * 2,0,0>
    #include "cube2.inc"

    #if (CorCubeLevel = TotalLevel-1) #render "1\n" #end
    #declare CorCubeCen = CorCubeCen + <-CorCubeRad * 2,CorCubeRad,0>
    #include "cube2.inc"
    #declare CorCubeCen = CorCubeCen + <CorCubeRad,0,0>
    #include "cube2.inc"
    #declare CorCubeCen = CorCubeCen + <CorCubeRad,0,0>
    #include "cube2.inc"

    // Restore to original calling values
    #declare CorCubeCen = CorCubeCen + <-CorCubeRad,-CorCubeRad,-CorCubeRad>
    #declare CorCubeRad = CorCubeRad * 3
    #declare CorCubeLevel = CorCubeLevel + 1
#end

